

   MEMBER('clonefile.clw')                            ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABREPORT.INC'),ONCE

                     MAP
                       INCLUDE('CLONE005.INC'),ONCE        !Local module procedure declarations
                     END


Shankar PROCEDURE                                     !Generated from procedure template - Process

Progress:Thermometer BYTE
LOC:SourceFile       STRING(100)
Process:View         VIEW(Names)
                     END
locNames             FILE,DRIVER('TOPSPEED'),PRE(lNAM),BINDABLE,CREATE,Name(LOC:SourceFile) ! 
SysIDKey                 KEY(lNAM:SysID),NOCASE,OPT,PRIMARY                                ! 
NameKey                  KEY(lNAM:LastName,lNAM:FirstName),DUP,NOCASE,OPT                  ! by &Name
Record                   RECORD,PRE()
SysID                       LONG                                                           ! 
LastName                    STRING(20)                                                     ! 
FirstName                   STRING(20)                                                     ! 
State                       STRING(2)                                                      ! 
                         END
                     END                       
ProgressWindow       WINDOW('Progress...'),AT(,,142,59),CENTER,TIMER(1),GRAY,DOUBLE
                       PROGRESS,USE(Progress:Thermometer),AT(15,15,111,12),RANGE(0,100)
                       STRING(''),AT(0,3,141,10),USE(?Progress:UserString),CENTER
                       STRING(''),AT(0,30,141,10),USE(?Progress:PctText),CENTER
                       BUTTON('Cancel'),AT(45,42,50,15),USE(?Progress:Cancel)
                     END

ThisWindow           CLASS(ReportManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
                     END

ThisProcess          ProcessClass                     !Process Manager
ProgressMgr          StepLongClass                    !Progress Manager

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Shankar')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Progress:Thermometer
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  Relate:Names.Open
  SELF.FilesOpened = True
  OPEN(ProgressWindow)
  SELF.Opened=True
  ProgressMgr.Init(ScrollSort:AllowNumeric,)
  ThisProcess.Init(Process:View, Relate:Names, ?Progress:PctText, Progress:Thermometer, ProgressMgr, NAM:SysID)
  ThisProcess.AddSortOrder(NAM:SysIDKey)
  ProgressWindow{Prop:Text} = 'Processing Records'
  ?Progress:PctText{Prop:Text} = '0% Completed'
  SELF.Init(ThisProcess)
  ?Progress:UserString{Prop:Text}=''
  SELF.AddItem(?Progress:Cancel, RequestCancelled)
  SEND(Names,'QUICKSCAN=on')
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Names.Close
  END
  ProgressMgr.Kill()
  GlobalErrors.SetProcedureName
  RETURN ReturnValue

